%% main function for sheet 2, ex. 1
clear all;
clc

%% *** Test the function myLuRows, myLuCols, myLuRowsVec and myLuColsVec
A = rand(10);                 % Create random 10-by-10 matrix
 
        % Calculate LU-decomposition w. myLuCols
        % Check if the result is correct 

        % Calculate LU-decomposition w. myLuRows
        % Check if the result is correct 

        % Calculate LU-decomposition w. myLuFull
        % Check if the result is correct 


%% *** Compare times
N = [2.^(3:8),400,600,800,1000,1400];

for k = 1:numel(N)
  n = N(k)
                  % Create random n-by-n matrix A

  tic
                  % Calculate LU-Decomposition with myLuCols
  timeLuC(k) = toc;
  
  tic
                  % Calculate LU-Decomposition with myLuRows
  timeLuR(k) = toc;
  
  tic
                  % Calculate LU-Decomposition with myLuFull  
  timeLuF(k) = toc;
  
end

%% *** plot the times
figure(1)
loglog(N,timeLuC  ,'ro-')
hold on
loglog(N,timeLuR ,'ko-')
loglog(N,timeLuF , 'g*-')
hold off
legend('myLuCols','myLuRows','myLuFull','Location','NorthWest')

xlim([4,1800])
xlabel('N')
ylabel('time [s]')
title('Computation times for the LU-decomposition')

