% main2, sheet 2, ex 2
clear all; clc
%% Matlab build in version
A=toeplitz([1,-ones(1,59)],[1,zeros(1,59)]);% define matrix
A(:,60)=1;

randn('state', 3383)                        % define linear system
x=randn(60,1);
b=A*x;

N = 500;

tic   
for i=1:N
    x_matlab = A\b;                         % solve using \
end
time_matlab = toc;

rel_err_matlab = norm(x-x_matlab)/norm(x)   % calculate relative error

%% LU decomposition with column pivotization
warning off all
tic
for i=1:N
                     % LU decomposition with column pivotization
                     % solve equation system to obtain x_col
    
end
time_col = toc;
rel_err_col = norm(x-x_col)/norm(x);        % compute relative error

%% LU decomposition with row pivotization

tic
for i=1:N
                     % LU decomposition with row pivotization
                     % solve equation system to obtain x_row
    
   
end
time_row = toc;
rel_err_row = norm(x-x_row)/norm(x);        % compute relative error

%% LU decomposition with full pivotization

tic
for i=1:N
                    % LU decomposition with full pivotization
                    % solve equation system to obtain x_full
    
	 
end
time_full = toc;
rel_err_full = norm(x-x_full)/norm(x);      % compute relative error

%% Print Times and Errors

fprintf(1, ' Method      Error    Time (per %i solves) \n', N);
fprintf(1, '---------------------------------------\n');
fprintf(1, ' Matlab    %5.3e     %2.5f\n', rel_err_matlab, time_matlab);
fprintf(1, ' Col Piv.  %5.3e     %2.5f\n', rel_err_col, time_col);
fprintf(1, ' Row Piv.  %5.3e     %2.5f\n', rel_err_row, time_row);
fprintf(1, ' Full Piv. %5.3e     %2.5f\n', rel_err_full, time_full);